<?php

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
   die("<br><strong>This script is only meant to run at the command line.</strong>");
}
$no_http_headers = true;

include(dirname(__FILE__) . "/../include/global.php");
include(dirname(__FILE__) . "/../lib/snmp.php");

$oids = array(
	"index" 		=> ".1.3.6.1.2.1.2.2.1.1",
	"name" 			=> ".1.3.6.1.4.1.193.81.3.4.1.1.1.1.1",
	"type" 			=> ".1.3.6.1.2.1.2.2.1.2",
	"status" 		=> ".1.3.6.1.4.1.193.81.3.4.3.1.2.1.7",
	"txpower" 		=> ".1.3.6.1.4.1.193.81.3.4.3.1.3.1.1",
	"rxlevel" 		=> ".1.3.6.1.4.1.193.81.3.4.3.1.3.1.10",
	"modulation"		=> ".1.3.6.1.4.1.193.81.3.4.1.1.14.1.7"
	);

$hostname 	= $_SERVER["argv"][1];
$host_id 	= $_SERVER["argv"][2];
$snmp_auth 	= $_SERVER["argv"][3];
$cmd 		= $_SERVER["argv"][4];

/* support for SNMP V2 and SNMP V3 parameters */
$snmp = explode(":", $snmp_auth);
$snmp_version 	= $snmp[0];
$snmp_port    	= $snmp[1];
$snmp_timeout 	= $snmp[2];
$ping_retries 	= $snmp[3];
$max_oids		= $snmp[4];

$snmp_auth_username   	= "";
$snmp_auth_password   	= "";
$snmp_auth_protocol  	= "";
$snmp_priv_passphrase 	= "";
$snmp_priv_protocol   	= "";
$snmp_context         	= "";
$snmp_community 		= "";

if ($snmp_version == 3) {
	$snmp_auth_username   = $snmp[6];
	$snmp_auth_password   = $snmp[7];
	$snmp_auth_protocol   = $snmp[8];
	$snmp_priv_passphrase = $snmp[9];
	$snmp_priv_protocol   = $snmp[10];
	$snmp_context         = $snmp[11];
}else{
	$snmp_community = $snmp[5];
}

/*
 * process INDEX requests
 */
if ($cmd == "index") {
	$return_arr = getJustRF();
	for ($i=0;($i<sizeof($return_arr));$i++) {
		print $return_arr[$i] . "\n";
	}

/*
 * process NUM_INDEXES requests
 */
}elseif ($cmd == "num_indexes") {
	$return_arr = getJustRF();
	print sizeof($return_arr) . "\n";	

/*
 * process QUERY requests
 */
}elseif ($cmd == "query") {
	$arg = $_SERVER["argv"][5];

	getJustRF($cmd,$arg);

/*
 * process GET requests
 */
}elseif ($cmd == "get") {
	$arg = $_SERVER["argv"][5];
	$index = $_SERVER["argv"][6];
	
	getJustRF($cmd,$arg,$index);

}else {
	print "ERROR: Invalid command given\n";
}

function reindex($arr) {
	$return_arr = array();

	for ($i=0;($i<sizeof($arr));$i++) {
		$return_arr[$i] = $arr[$i]["value"];
	}
	return $return_arr;
}


function getJustRF($cmd='', $arg='', $index = '') { 
	global $hostname, $snmp_community, $oids, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids;

	$arr_index = $return_arr = array();
	
	$array_index = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["index"], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));
	$array_tipo = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids["type"], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));

        for ($i=0;($i<sizeof($array_index));$i++) {
                if ($array_tipo[$i] == "RF") { 
                        $return_arr[] = $array_index[$i];
			$arr_index[] = $i;
		} 
  	}
	
if ((($cmd == "query") or ($cmd == "get")) and ($arg <> '')) {
	$array_arg = reindex(cacti_snmp_walk($hostname, $snmp_community, $oids[$arg], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, SNMP_POLLER));
	foreach ($arr_index as $key => $value) { 
		if (($arg == "txpower") or
		   ($arg == "rxlevel") or
		   ($arg == "status") or
		   ($arg == "name") or 
		   ($arg == "modulation")
		) {
			$arr_arg_filter[] = $array_arg[$key];
		} else {
			$arr_arg_filter[] = $array_arg[$value];
		}
	}	
	if ($cmd=="query") { 	
	        for ($i=0;($i<sizeof($return_arr));$i++) {
        	       print $return_arr[$i] . "!" . $arr_arg_filter[$i] . "\n";
        	}
	} else {
 		if ($index <> "") { 
		        for ($i=0;($i<sizeof($return_arr));$i++) {
				if ($return_arr[$i] == $index) 
					print $arr_arg_filter[$i];
			}
		}
	} 
} else {
	return $return_arr;
}	
}

?>
